/**
 * 
 */
package com.example.client.view;

import com.example.client.service.MyService;
import com.example.client.service.MyServiceAsync;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.Composite;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.TextBox;

/**
 * @author davis
 *
 */
public class SayHelloWidget extends Composite {
	
	private MyServiceAsync service = GWT.create(MyService.class);
	private HorizontalPanel hPanel = new HorizontalPanel();
	private TextBox box = new TextBox();
	private Label label = new Label();
	private Button button = new Button("Say hello to the server");
	private AsyncCallback<String> callback;
	
	
	public SayHelloWidget() {
		
		hPanel.add(new Label("Enter your name:"));
		hPanel.add(box);
		hPanel.add(button);
		hPanel.add(label);
		hPanel.setSpacing(10);
		
		this.initWidget(hPanel);
		
		button.addClickHandler(new ClickHandler() {

			public void onClick(ClickEvent arg0) {
				service.sayHello(box.getText(), callback);
			}});
		
		callback = new AsyncCallback<String>() {

			public void onFailure(Throwable t) {
				Window.alert("Service call failed: "+t.getMessage());
			}

			public void onSuccess(String msg) {
				label.setText(msg);
			}};
	}
	
	public SayHelloWidget(String name) {
		this();
		box.setText(name);
	}

}
